  PAGE    60,132
  TITLE   fxVA.ASM -- PCX Effects
  SUBTTL  Copyright (c) Genus Microprogramming, Inc. 1988-89

; fxVA.ASM                                                                   ;
; Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.   ;

;****************************************************************************;
;                                                                            ;
; This file contains procedures for taking a pcx virtual buffer and          ;
; 'sanding' it on the display.                                               ;
;                                                                            ;
; Procedures: fxVirtualSand                                                  ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
; Microsoft ASM 5.x version.              Programmer: Chris Howard  3/15/89  ;
;                                                                            ;
;****************************************************************************;

; Include files
  INCLUDE ..\inc\pcxDefs.inc
  INCLUDE ..\inc\pcxMacs.inc
  INCLUDE ..\inc\pcxErrs.inc

  INCLUDE ..\inc\fxDefs.inc
  INCLUDE ..\inc\fxMacs.inc
  INCLUDE ..\inc\fxErrs.inc

  @SetModel

  @BegData
  @EndData

  @BegCode

          EXTRN     pcxVirtualDisplay       : FAR
          EXTRN     fxEffectDelay           : FAR

          PUBLIC    fxVirtualSand 

;**********

;
; This is the Virtual Sand effect procedure, for the fxVirtualEffect
; interface.  It is an INTERNAL routine only.
;
; On Entry:  SS:BP    points to pcxVirtualEffect frame
;            ES:DI    points to display structure
;            DS:SI    points to buffer
;
; On Exit:   retcode  contains error code, if any
;

fxVirtualSand       PROC FAR

          mov       ax,vedir                ;What direction?
          cmp       ax,fxUP                 ;Right and up  
          jne       fxVA_down       

          jmp       SHORT fxVA_up   

fxVA_down:
                                        
          mov       si,vedepth              ;Initialize loop counter
          dec       si

fxVA_mainloop:

          mov       di,0                    ;Init inner loop

fxVA_loop:

          mov       ax,vevseg               ;vptr
          push      ax
          mov       ax,vevofs
          push      ax
          xor       ax,ax                   ;vx   = 0
          push      ax
          push      si                      ;vy   = loop
          mov       ax,vex                  ;x    = x
          push      ax
          mov       bx,vey                  ;y    = y+loop
          add       bx,di
          push      bx
          mov       ax,vex2                 ;x2   = x2
          push      ax                           
          push      bx                      ;y2   = y+loop
          mov       ax,vepage               ;page = current
          push      ax                      

          call      pcxVirtualDisplay       ;Display this part

          inc       di                      ;Bump inner loop
          cmp       di,si                   ;Have we 'sanded' to the bottom?
          jle       fxVA_loop               ;If not, loop

          mov       ax,vedelay              ;Get the delay count
          push      ax

          call      fxEffectDelay           ; and delay

          jnc       fxVA_bump               ;If no error, continue
          jmp       SHORT fxVA_error              

fxVA_bump:

          dec       si                      ;Bump main loop
          cmp       si,0                    ;Have we done all lines?
          jge       fxVA_mainloop           ;If not, loop

          @SetRet   veret,fxSUCCESS         ;Set the return code
          jmp       SHORT fxVA_exit

fxVA_up:
                                        
          mov       si,0                    ;Initialize loop counter

fxVA_upmainloop:

          mov       di,vedepth              ;Init inner loop

fxVA_uploop:

          mov       ax,vevseg               ;vptr
          push      ax
          mov       ax,vevofs
          push      ax
          xor       ax,ax                   ;vx   = 0
          push      ax
          push      si                      ;vy   = loop
          mov       ax,vex                  ;x    = x
          push      ax
          mov       bx,vey                  ;y    = y+loop
          add       bx,di
          push      bx
          mov       ax,vex2                 ;x2   = x2
          push      ax                           
          push      bx                      ;y2   = y+loop
          mov       ax,vepage               ;page = current
          push      ax                      

          call      pcxVirtualDisplay       ;Display this part

          dec       di                      ;Bump inner loop
          cmp       di,si                   ;Have we 'sanded' to the top?
          jge       fxVA_uploop             ;If not, loop

          mov       ax,vedelay              ;Get the delay count
          push      ax

          call      fxEffectDelay           ; and delay

          jnc       fxVA_upbump             ;If no error, continue
          jmp       SHORT fxVA_error              

fxVA_upbump:

          inc       si                      ;Bump main loop
          cmp       si,vedepth              ;Have we done all lines?
          jl        fxVA_upmainloop         ;If not, loop

          @SetRet   veret,fxSUCCESS         ;Set the return code
          jmp       SHORT fxVA_exit

fxVA_error:

          @SetRet   veret,ax                ;Set the error

fxVA_exit:

          @Exit     veret,veparm            ;Return

fxVirtualSand       ENDP

  @EndCode

          END
